/*******************   ARQUIVO   LISTA.C   *********************/
# define NOMAIN

# include <stdio.h>
# include <stdlib.h>

# include "include.h"
# include "struct.h"
# include "global.h"

char *reserve();

init_lista()
{
ini_lista=fim_lista=NULL;
}

apag_event(event)
EVENT 	*event;
{
if(event == ini_lista)
  {
  ini_lista = event->next;
  ini_lista->prec=NULL;
  free(event);
  return(0);
  }
if(event == fim_lista)
  {
  fim_lista = event->prec;
  fim_lista ->next=NULL;
  free(event);
  return(0);
  }

  (event->prec)->next = event->next;
  (event->next)->prec = event->prec;
  free(event);
  return(0);
  }

insere_event(event)
EVENT	*event;
{
EVENT 	*ev;

if(ini_lista == NULL)
  {
  ini_lista=fim_lista=event;
  event->next=event->prec=NULL;
  return(0);
  }

if(ini_lista->t_event >= event->t_event)
  {
  event->prec = NULL;
  event->next = ini_lista;
  ini_lista->prec = event;
  ini_lista=event;
  return(0);
  }

for(ev=ini_lista;ev != NULL; ev=ev->next)
  {
  if(ev->t_event >= event->t_event)
    {
    event->prec = ev->prec;
    event->next = ev;
    (ev->prec)->next = event;
    ev->prec = event;
    return(0);
    }
  }

  fim_lista->next=event;
  event->prec=fim_lista;
  event->next=NULL;
  fim_lista=event;
  return(0);

}

EVENT *init_event(tipo,obj,t_event)
int 	tipo;
FONTE	*obj;
float 	t_event;
{
EVENT 	*event;

event = (EVENT *)reserve (sizeof(struct TYP_EVENT));
event->t_event=t_event;
event->tipo = tipo;
switch(tipo) {
  case COD_FONTE     : event->objeto.fonte = (FONTE *)obj;
                       break;
  case COD_SERVIDOR  : event->objeto.servidor = (SERVIDOR *)obj;
                       break;
  default: return(NULL);
             }

return(event);
}

