/*******************     ARQUIVO MAIN.C    **********************/
# define MAIN

# include <stdio.h>
# include <malloc.h>
# include <stdlib.h>

# include "include.h"
# include "struct.h"
# include "global.h"

# define ESC 0x1b

main(argc,argv)
int argc;
char **argv;

{
int t,i;
int tipo_fim;
EVENT *event;

flag_trace=FALSE;
system("cls");
printf("Simulador de Filas, versao 1.0, Maio 1990\n\n");



if(argc != 2)
  {
  printf(" Uso : fila nome_arquivo \n");
  exit(1);
  }

init_dados(argv[1]);
init();
init_rand();
init_lista_event();

if(flag_trace == 1)
  {
  fprintf(stderr," Fila executando  : Tsimul / Nfregues = ");
  fprintf(stderr,"%c[s",ESC);
  }

while(!(tipo_fim=break_cond()))
  {

  if(flag_trace == 1)
  {
  fprintf(stderr,"%c[u",ESC);
  fprintf(stderr,"%12.2f / %7d",t_simul,n_fregues);
  }

  event=ini_lista;


  if(event->t_event != t_simul)
    t_simul = event->t_event;


  if(event->tipo == COD_FONTE)
    {
    proc_fonte(event->objeto.fonte);
    if(flag_trace==2) affliste();
    apag_event(event);
    continue;
    }

  if(event->tipo == COD_SERVIDOR)
    {
    proc_serv(event->objeto.servidor);
    if(flag_trace==2) affliste();
    apag_event(event);
    }
  }
mostra_resul(tipo_fim-1);

}

break_cond()
{
int fim=0;

if(t_simul >= t_max_simul)
   fim = 1;
if(n_fregues >= n_max_fregues)
   fim =2;

return(fim);
}

affliste()
{
EVENT 	*ev;
int 	i,j,k;
float 	t;

printf("Tsimul = %f\n",t_simul);
i=0;
for(ev=ini_lista;ev != NULL;ev=ev->next)
  {
  printf("Event no %i :",i++);
  switch(ev->tipo) {
	case COD_SERVIDOR : printf("Servidor %s\t ",(ev->objeto.servidor)->nome);
  	                    break;
   	case COD_FONTE    : printf("Fonte    %s\t ",(ev->objeto.fonte)->nome);
  	                    break;
	default           : printf("  ????   ");
			    break;
		       }
  printf("Tev = %f\n",ev->t_event);
  }
/*printf("\n	       < RETURN > para continuar ...");
getchar();*/
printf("\n\n");
}
