/* Esta subrotina e responsavel pela emissao dos resultados obtidos do
   simulador  */

# define NOMAIN       
                      
# include <stdio.h>   
# include <stdlib.h>  
                      
# include "include.h" 
# include "struct.h"
# include "global.h"  

mostra_resul(termino)

int termino;

{

/* Variaveis externas usadas neste programa  

   int 		n_fila   : numero de filas existentes na rede
   
   int		n_serv   : numero de servidores existentes na rede
   
   int		n_fonte  : numero de fontes na rede
   
   float 	t_simul  : tempo simulado total
   
                                                        */

/* Declaracao de variaveis de estatisticas das FONTES */

int	num_cli_ger = 0;


/* Declaracao de variaveis de estatisticas dos SERVIDORES */

float 	util = 0.0;
flag	cli_fim_serv = 0;
int	num_cli_serv = 0;
float	tx_serv = 0.0;

/* Declaracao de variaveis de estatisticas de FILAS */

float 	taxa_cheg     = 0.0;
float 	taman_med_fil = 0.0;
float	tempo_med_fil = 0.0;
int	num_max_cli   = 0;
int	num_cli_ter   = 0;

/* Decalracao de variaveis para fins gerais */

int	cli_tot = 0;

int	tipo = 0;
float	t_proc_medio = 0.0;
float	t_proc_inf = 0.0;
float	t_proc_sup = 0.0;

int 	i = 0;

/*     IMPRESSAO DO CABECALHO    */

printf(" %s \n\n %s \n %s \n %s \n %s \n %s",
        "SIMULADOR DE REDES DE FILAS ABERTAS",
        "TRABALHO DA MATERIA : SIMULACAO DIGITAL",
        "PERIODO             : 89.2",
        "ALUNOS : SERGIO DE FIGUEIREDO BRITO",
        "         LIRIDA ALVES BARROS       ",
        "         IVAN SARAIVA              ");

printf("\n\n %s",
        "TIPO DO TERMINO : ");

if (termino == 0)
	{
	printf("%s","tempo simulado estipulado");
	}
	else
	{
	printf("%s","numero de clientes estipulado");
	}

printf("\n\n %s %10.2f",
        "********** TEMPO SIMULADO           : ",t_simul);

for(i=1 ;i<n_fonte+1 ;i++) cli_tot+=tab_fonte[i].n_tot; 

printf("\n %s %10d",
	"********** NUM. DE CLIENTES GERADOS : ",cli_tot);

/*  IMPRESSAO DAS FONTES   */

printf("\n\n %s \n\n %s \n %s",
	"******************** FONTES ********************",
	"LEGENDA :", "---------");

printf("\n\n %s \n\n %s \n %s \n %s",
	"NUM.CLIENTE.GER  ==> numero de clientes gerados pela FONTE",
	"TEMPO DE GERACAO ==> proveniente do arquivo de entrada de dados",
	"	             [1] - exponencial ==> [1] MED :__",
	"                    [2] - uniforme    ==> [2] INF :__ SUP :__");

printf("\n\n %s \n %s ",
        "FONTE - NUM.CLIENTE.GER. - TAXA DE GERACAO",
	"           [clientes]       [uts/cliente]      ");

for(i=1 ;i<n_fonte+1 ;i++ )
	{
        printf("\n %s",
        "----------------------------------------------------------------");
        tipo=tab_fonte[i].tipo;
        num_cli_ger=tab_fonte[i].n_tot;
	printf("\n %4d %13d",i,num_cli_ger);
        switch(tipo)
        	{
        	case 1 :
        		t_proc_medio=tab_fonte[i].t_proc_medio;
			printf(" %s %6.2f",
	"       [1] MED :",t_proc_medio);
			break;

        	case 2 :
        		t_proc_inf=tab_fonte[i].t_proc_inf;
        		t_proc_sup=tab_fonte[i].t_proc_sup;
			printf(" %s %6.2f %s %6.2f",
	"       [2] INF :",t_proc_inf," SUP :",t_proc_sup);
			break;

		}
	}

printf("\n 	Tecla <RETURN> para continuar -->");
getch();
system("cls");

/*    IMPRESSAO   DOS   SERVIDORES     */

/*  BOTAR PULO DE PAGINA  */

printf(" %s \n\n %s \n %s",
        "******************** SERVIDORES ********************",
        "LEGENDA :", "---------");

printf("\n\n %s \n %s \n\n %s \n %s \n\n %s \n\n %s \n %s \n\n %s \n %s \n %s",
	"UTILIZACAO       ==> parte do tempo que o servidor processou ",
        "                    clientes frente ao tempo total simulado",
	"CLI.FIM.         ==> se o servidor tem cliente em servico no final",
        "                    da simulacao : 0 -> NAO ; 1 -> SIM.",
	"NUM.CLI.         ==> numero total de clientes servidos",
	"TX DE SERVICO    ==> tempo medio para servico de um cliente",
        "		     calculado pelo simulador",
	"TEMPO DE SERVICO ==> proveniente do arquivo de entrada de dados",
        "		     [1] - exponencial ==> [1] MED :__",
        "                    [2] - uniforme    ==> [2] INF :__ SUP :__");

printf("\n\n %s \n %s",
  "SERV. - UTILIZ. - CLI.FIM. - NUM.CLI. - TX DE SERVICO - TEMPO DE SERVICO",
  "                   [0-1]    [clientes]  [cliente/uts]   [uts/cliente]");

for(i=1 ;i<n_serv+1 ;i++ )
	{
        printf("\n %s",
        "----------------------------------------------------------------");
	tipo=tab_serv[i].tipo;
        util=( tab_serv[i].t_tot_ocupado/t_simul );
	cli_fim_serv=tab_serv[i].fregues;
        num_cli_serv=tab_serv[i].n_tot;
	tx_serv=(num_cli_serv/(t_simul*util));
	printf("\n %4d %9.2f %8d %10d %12.2f", i, util, cli_fim_serv, num_cli_serv, tx_serv );
        switch(tipo)
        	{
        	case 1 :
        		t_proc_medio=tab_serv[i].t_proc_medio;
			printf(" %s %5.2f",
	"     [1] MED :",t_proc_medio);
			break;

        	case 2 :
        		t_proc_inf=tab_serv[i].t_proc_inf;
        		t_proc_sup=tab_serv[i].t_proc_sup;
			printf(" %s %5.2f %s %5.2f",
	"     [2] INF :",t_proc_inf," SUP :",t_proc_sup);
			break;

		}
	}

printf(" \n	Tecla <RETURN> para continuar -->");
getch();
system("cls");

/*     IMPRESSAO   DAS  FILAS     */

printf("\n\n\n %s \n\n %s \n %s",
        "******************** FILAS ********************",
        "LEGENDA :", "---------");

printf("\n\n %s \n\n %s \n\n %s \n\n %s \n\n %s",
	"TX.CHG.      ==> taxa de chegada media de fregueses na fila",
	"TAM.MED.FIL. ==> numero media de clientes na fila",
	"TEM.MED.FIL. ==> tempo medio de espera de um cliente na fila",
	"MAX.CLI.     ==> numero maximo de clientes ocorrido na fila",
	"CLI.TER.     ==> numero de clientes na fila no termino da simulacao");

printf("\n\n\n %s \n %s",
	"FILA - TX.CHG. - TAM.MED.FIL - TEM.MED.FIL - MAX.CLI. - CLI.TER.",
        "      [cli/uts]  [clientes]       [uts]     [clientes] [clientes]");

for(i=1 ;i<n_fila+1 ;i++ )
	{
        printf("\n %s",
        "----------------------------------------------------------------");
	if (tab_file[i].saida!=NULL)
		{
		taxa_cheg = (tab_file[i].n_tot/t_simul);
		taman_med_fil = (tab_file[i].tot_tam_acum/t_simul);
		tempo_med_fil = (taman_med_fil/taxa_cheg);
		num_max_cli = tab_file[i].n_max;
		num_cli_ter = tab_file[i].n_cour;
		printf("\n %4d %8.2f %12.2f %14.2f %10d %10d",i, taxa_cheg ,
		taman_med_fil, tempo_med_fil, num_max_cli, num_cli_ter);
		}
	else
		{
		num_cli_ter = tab_file[i].n_cour;
		printf("\n %s %10d",
		"SORVEDOURO                                          ",
		num_cli_ter);
		}
	}
	printf("\n");
}
